from fuzzySet import *
def fuzzyOrWang(A,x,B,y):#■WangとMendelによるOR演算
    i=int(x*100+0.5);j=int(y*100+0.5)
    return A[i]+B[j]-A[i]*B[j]
def fuzzyAndWang(A,x,B,y):#■WangとMendelによるAND演算
    i=int(x*100+0.5);j=int(y*100+0.5)
    return A[i]*B[j]
def fuzzyOr2(A,x,B,y):#■x,yが独立のときのOR演算
    i=int(x*100+0.5);j=int(y*100+0.5)
    if A[i]>B[j]:return A[i]
    return B[j]
def fuzzyAnd2(A,x,B,y):#■x,yが独立のときのAND演算
    i=int(x*100+0.5);j=int(y*100+0.5)
    if A[i]<B[j]:return A[i]
    return B[j]
def fuzzyFixY(fun, A,B,y):#■y固定のときの集合
    F=[0.0 for i in range(101)]
    for i in range(101):F[i]=fun(A,float(i)/100,B,y)
    return F
def fuzzyFixX(fun, A,B,x):#■x固定のときの集合
    F=[0.0 for i in range(101)]
    for i in range(101):F[i]=fun(A,x,B,float(i)/100)
    return F
def rangeD(D,D1,D2):#■範囲チェック
    if D<D1: return D1
    if D>D2: return D2
    return D
def setColor(V):#■色コード設定
    R=0;G=0;B=0
    if V>=1 : R=255
    elif V>=0.75: R=255;G=int(255-(V-0.75)*255*4)
    elif V>=0.5:R=int((V-0.5)*255*4);G=255
    elif V>=0.25:G=int(V*255*2)
    else: G=int(V*255*2); B=127-G
    return "#%02X%02X%02X" %(rangeD(R,0,255),
                             rangeD(G,0,255),
                             rangeD(B,0,255))
def drawColorMap(canvas, fun, A,B):#■x,yが独立のときの色マップ表示
    for i in range(101):
        y=float(i)/100;Y=420-i*4;
        for j in range(101):
            x=float(j)/100
            V=float(fun(A,x,B,y)); X=10+j*4
            canvas.create_rectangle(X,Y,X+4,Y+4,
                                     fill=setColor(V),
                                     outline="black")
def setX(X):return X*500+500 #■X座標変換
def setY(Y):return 620-Y*500 #■Y座標変換
def drawPolygon(canvas,X1,Y1,X2,Y2,X3,Y3,X4,Y4,CL,outline=""):
    canvas.create_polygon(setX(X1),setY(Y1),setX(X2),setY(Y2),
                          setX(X3),setY(Y3),setX(X4),setY(Y4),
                          fill=CL,outline=outline)
def drawThLine(canvas,X1,Y1,X2,Y2):#■太線表示
    canvas.create_line(setX(X1),setY(Y1),setX(X2),setY(Y2),
                       fill="Black",width=2)
def birdView(canvas, fun, A,B,outline=""):#■x,yが独立のときの鳥瞰図表示
    AA=math.pi/6;BB=math.pi/6;# 擬似3次元表示順偽
    cosA=math.cos(AA)/100;sinA=math.sin(AA)/100;
    cosB=math.cos(BB)/100;sinB=math.sin(BB)/100
    for i in range(100,0,-1):
        fi=float(i);y=fi/100;
        XS=fi*cosB;YS=fi*sinB # Y軸の画面内位置
        for j in range(100,0,-1):
            fj=float(j); x=fj/100;
            V1=fun(A,x,B,y); V2=fun(A,x,B,y-0.01)
            V3=fun(A,x-0.01,B,y-0.01); V4=fun(A,x-0.01,B,y)
            X1=XS-fj*cosB;Y1=YS+fj*sinA  #  (X1,Y1)----(X4,Y4)      
            X2=X1-cosB;Y2=Y1-sinB        #     |          |
            X3=X2+cosA;Y3=Y2-sinA        #     |          |
            X4=X1+cosA;Y4=Y1-sinA        #  (X2,Y2)----(X3,Y3)
            Y1+=V1/5;Y2+=V2/5;Y3+=V3/5;Y4+=V4/5# Z座標加算
            drawPolygon(canvas,X1,Y1,X2,Y2,X3,Y3,X4,Y4,
                        setColor((V1+V2+V3+V4)/4),outline=outline)
            if i % 10==0 :drawThLine(canvas,X1,Y1,X4,Y4)
            if j % 10 ==0:drawThLine(canvas,X1,Y1,X2,Y2)
    for i in range(100,0,-1):# Y境界(X=0の線）
        fi=float(i);y=fi/100;
        X1=fi*cosB;Y1=fi*sinB; X2=X1-cosB;Y2=Y1-sinB
        V1=fun(A,0,B,y);V2=fun(A,0,B,y-0.01)
        YY1=Y1+V1/5;YY2=Y2+V2/5
        drawPolygon(canvas,X1,YY1,X2,YY2,X2,Y2,X1,Y1,
                    "#0077FF",outline=outline)
        drawThLine(canvas,X1,YY1,X2,YY2)
        drawThLine(canvas,X1,Y1,X2,Y2)
        if i==100:drawThLine(canvas,X1,YY1,X1,Y1)
        elif i==1:drawThLine(canvas,X2,YY2,X2,Y2)
    for i in range(100,0,-1):# X境界(Y=0の線）
        fi=float(i);x=fi/100;
        X1=-fi*cosA;Y1=fi*sinA;X2=X1+cosA;Y2=Y1-sinA
        V1=fun(A,x,B,0); V2=fun(A,x-0.01,B,0)
        YY1=Y1+V1/5;YY2=Y2+V2/5
        drawPolygon(canvas,X1,YY1,X2,YY2,X2,Y2,X1,Y1,
                    "#0077FF",outline=outline)
        drawThLine(canvas,X1,YY1,X2,YY2)
        drawThLine(canvas,X1,Y1,X2,Y2)
        if i==100:drawThLine(canvas,X1,YY1,X1,Y1)
        elif i==1:drawThLine(canvas,X2,YY2,X2,Y2)
